﻿using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Data;
using HeuristicLab.Encodings.RealVectorEncoding;
using HeuristicLab.Optimization;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Algorithms.SAPBA.Operators {
  [Item("FixedRealVectorCreator", "An operator which creates a new real vector cloned from a single Point")]
  [StorableClass]
  public class FixedRealVectorCreator : RealVectorCreator, IStrategyParameterCreator {
    [Storable]
    private RealVector Point;

    [StorableConstructor]
    protected FixedRealVectorCreator(bool deserializing) : base(deserializing) { }
    protected FixedRealVectorCreator(FixedRealVectorCreator original, Cloner cloner) : base(original, cloner) {
      Point = cloner.Clone(original.Point);
    }
    public FixedRealVectorCreator(RealVector r) : base() {
      Point = r;
    }
    public override IDeepCloneable Clone(Cloner cloner) { return new FixedRealVectorCreator(this, cloner); }
    protected override RealVector Create(IRandom random, IntValue length, DoubleMatrix bounds) {
      return (RealVector)Point.Clone();
    }
  }

}

